// BlackHoleProxyConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BlackHoleProxyConfig.h"
#include "BlackHoleProxyConfigDlg.h"
#include <io.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static LPCTSTR CONFIG_DAT = _T("BlackHoleProxy.dat");

#define DEFAULT_PORT 3421

/////////////////////////////////////////////////////////////////////////////
// CBlackHoleProxyConfigDlg dialog

CBlackHoleProxyConfigDlg::CBlackHoleProxyConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlackHoleProxyConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBlackHoleProxyConfigDlg)
	m_strGraphicsFile = _T("");
	m_bPac = FALSE;
	m_bServer = FALSE;
	//}}AFX_DATA_INIT
	m_nPort = DEFAULT_PORT;
	m_nPacPort = m_nPort;
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBlackHoleProxyConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlackHoleProxyConfigDlg)
	DDX_Text(pDX, IDC_GRAPHICS_FILE, m_strGraphicsFile);
	DDV_MaxChars(pDX, m_strGraphicsFile, 255);
	DDX_Check(pDX, IDC_PAC, m_bPac);
	DDX_Check(pDX, IDC_SERVER, m_bServer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBlackHoleProxyConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CBlackHoleProxyConfigDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PAC, OnPac)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlackHoleProxyConfigDlg message handlers

BOOL CBlackHoleProxyConfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	RestoreSettings();
	UpdateData(FALSE);

	CString str;
	str.Format(_T("%d"), m_nPort);
	GetDlgItem(IDC_PORT)->SetWindowText(str);
	str.Format(_T("%d"), m_nPacPort);
	GetDlgItem(IDC_PAC_PORT)->SetWindowText(str);

	GetDlgItem(IDC_PAC_PORT)->EnableWindow(m_bPac);
	GetDlgItem(IDC_PORT)->SetFocus();

	return FALSE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBlackHoleProxyConfigDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBlackHoleProxyConfigDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBlackHoleProxyConfigDlg::OnPac() 
{
	CButton* pCheckBox = (CButton*)GetDlgItem(IDC_PAC);
	GetDlgItem(IDC_PAC_PORT)->EnableWindow(pCheckBox->GetCheck());
}

void CBlackHoleProxyConfigDlg::OnBrowse() 
{
	CString str;
	GetDlgItem(IDC_GRAPHICS_FILE)->GetWindowText(str);
	CFileDialog dlg(
		TRUE, 
		NULL, 
		str, 
		OFN_HIDEREADONLY, 
		_T("Graphics Files (*.jpg;*.gif)|*.jpg;*.gif||"));
	if (IDOK == dlg.DoModal())
	{
		GetDlgItem(IDC_GRAPHICS_FILE)->SetWindowText(dlg.GetPathName());
	}
}

void CBlackHoleProxyConfigDlg::OnOK() 
{
	CWaitCursor cur;
	UpdateData();

	CString str;
	GetDlgItem(IDC_PORT)->GetWindowText(str);
	m_nPort = _ttoi(str);
	if (0 == m_nPort)
	{
		m_nPort = DEFAULT_PORT;
	}
	GetDlgItem(IDC_PAC_PORT)->GetWindowText(str);
	m_nPacPort = _ttoi(str);
	if (0 == m_nPacPort)
	{
		m_nPacPort = m_nPort;
	}

	SaveSettings();

	StopProxy();
	// Hack - wait until the service is deleted.
	Sleep(500);
	StartProxy();

	CDialog::OnOK();
}

void CBlackHoleProxyConfigDlg::StopProxy()
{
	STARTUPINFO startupinfo;
    ZeroMemory(&startupinfo, sizeof(STARTUPINFO));
    startupinfo.cb = sizeof(STARTUPINFO);
	startupinfo.lpDesktop = _T("");
	startupinfo.dwFlags = 0;
	startupinfo.wShowWindow = SW_HIDE;

	PROCESS_INFORMATION processinfo;
    ZeroMemory(&processinfo, sizeof(PROCESS_INFORMATION));
	CreateProcess(
		NULL,
		_T("BlackHoleProxy.exe -terminate -silent"),
		NULL,
		NULL,
		FALSE,
		0,
		NULL,
		NULL,
		&startupinfo,
		&processinfo);
}

void CBlackHoleProxyConfigDlg::StartProxy(BOOL bSilent /*=FALSE*/)
{
	STARTUPINFO startupinfo;
    ZeroMemory(&startupinfo, sizeof(STARTUPINFO));
    startupinfo.cb = sizeof(STARTUPINFO);
	startupinfo.lpDesktop = _T("");
	startupinfo.dwFlags = 0;
	startupinfo.wShowWindow = SW_HIDE;

	PROCESS_INFORMATION processinfo;
    ZeroMemory(&processinfo, sizeof(PROCESS_INFORMATION));

	TCHAR szPath[MAX_PATH + 512];
	_tcscpy(szPath, _T("BlackHoleProxy.exe -silent"));

	if (m_nPort > 0)
	{
		_stprintf(szPath + _tcslen(szPath), _T(" port %d"), m_nPort);
	}
	if (m_bPac)
	{
		_tcscat(szPath, _T(" -pac"));
		if (m_nPacPort > 0)
		{
			_stprintf(szPath + _tcslen(szPath), _T(" %d"), m_nPacPort);
		}
	}
	if (m_bServer)
	{
		_tcscat(szPath, _T(" -server"));
	}
	if (!m_strGraphicsFile.IsEmpty())
	{
		_stprintf(szPath + _tcslen(szPath), _T(" -graphics %s"), m_strGraphicsFile);
	}
	if (bSilent)
	{
		_tcscat(szPath + _tcslen(szPath), _T(" -silent"));
	}

	CreateProcess(
		NULL,
		szPath,
		NULL,
		NULL,
		FALSE,
		0,
		NULL,
		NULL,
		&startupinfo,
		&processinfo);
}

void GetConfigFileName(LPTSTR szPath)
{
	::GetModuleFileName(AfxGetApp()->m_hInstance, szPath, MAX_PATH);
	LPTSTR p = _tcsrchr(szPath, _T('\\'));
	if (NULL == p)
	{
		p = szPath + _tcslen(szPath);
		*p = _T('\\');
	}
	p++;
	_tcscpy(p, CONFIG_DAT);
}

void CBlackHoleProxyConfigDlg::SaveSettings()
{
	m_doc.m_strGraphicsFile = m_strGraphicsFile;
	m_doc.m_bPac = m_bPac;
	m_doc.m_nPacPort = m_nPacPort;
	m_doc.m_nPort = m_nPort;
	m_doc.m_bServer = m_bServer;

	TCHAR szPath[MAX_PATH];
	GetConfigFileName(szPath);
	m_doc.DoSave(szPath);
}

void CBlackHoleProxyConfigDlg::RestoreSettings()
{
	TCHAR szPath[MAX_PATH];
	GetConfigFileName(szPath);
	if (_taccess(szPath, 0) != -1)
	{
		m_doc.OnOpenDocument(szPath);
	}

	m_strGraphicsFile = m_doc.m_strGraphicsFile;
	m_bPac = m_doc.m_bPac;
	m_nPacPort = m_doc.m_nPacPort;
	m_nPort = m_doc.m_nPort;
	m_bServer = m_doc.m_bServer;
}

void CBlackHoleProxyConfigDlg::AutoLaunch()
{
	RestoreSettings();
	StartProxy(TRUE);
}
